<% local view, viewlibrary, page_info, session = ... 
htmlviewfunctions = require("htmlviewfunctions")
html = require("acf.html")
%>

<script type="text/javascript">
	if (typeof jQuery == 'undefined') {
		document.write('<script type="text/javascript" src="<%= html.html_escape(page_info.wwwprefix) %>/js/jquery-latest.js"><\/script>');
	}
</script>

<script type="text/javascript">
	if (typeof $.tablesorter == 'undefined') {
		document.write('<script type="text/javascript" src="<%= html.html_escape(page_info.wwwprefix) %>/js/jquery.tablesorter.js"><\/script>');
	}
</script>

<script type="text/javascript">
	$(document).ready(function() {
		$("#list").tablesorter({headers: {0:{sorter: false}}, widgets: ['zebra']});
	});
</script>

<% htmlviewfunctions.displaycommandresults({"editfile", "deletefile"}, session) %>
<% htmlviewfunctions.displaycommandresults({"createfile"}, session, true) %>

<% if viewlibrary and viewlibrary.dispatch_component then 
	viewlibrary.dispatch_component("status")
end %>

<h1>Configuration</h1>
<dl><table id="list" class="tablesorter"><thead>
	<tr>
		<th>Action</th>
		<th>File</th>
		<th>Size</th>
		<th>Last Modified</th>
	</tr>
</thead><tbody>
<% for k,v in ipairs( view.value ) do %>
	<tr>
		<td>
		<% if viewlibrary.check_permission("editfile") then %>
			<%= html.link{value=page_info.script..page_info.prefix..page_info.controller.."/editfile?filename="..html.url_encode(v.filename).."&redir="..html.url_encode(page_info.orig_action), label="Edit "} %>
		<% end %>
		<% if viewlibrary.check_permission("deletefile") then %>
			<%= html.link{value=page_info.script..page_info.prefix..page_info.controller.."/deletefile?submit=true&filename="..html.url_encode(v.filename), label="Delete "} %>
		<% end %>
		</td>
                <td><%= html.html_escape(v.filename) %></td>
                <td><span class="hide"><%= html.html_escape(v.orig_size) %>b</span><%= html.html_escape(v.size) %></td>
                <td><%= html.html_escape(v.mtime) %></td>
	</tr>
<% end %>
</tbody></table></dl>

<% if viewlibrary and viewlibrary.dispatch_component and viewlibrary.check_permission("createfile") then
        local createform = viewlibrary.dispatch_component("createfile", nil, true) %>
<H2><%= html.html_escape(createform.label) %></H2>
<%
        createform.action = page_info.script .. page_info.prefix .. page_info.controller .. "/createfile"
	htmlviewfunctions.displayform(createform)
end %>
